// Any Device - API - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/common/api/gsc_types.h $
// $Rev: 31429 $
// $Date: 2014-11-13 09:34:27 -0600 (Thu, 13 Nov 2014) $

#ifndef __GSC_TYPES_H__
#define __GSC_TYPES_H__



#if (defined(WIN32) || defined(_WIN32) || defined(_WIN64))

	#include <windows.h>

	#define	GSC_EXPORT		WINAPI

	#ifndef GSC_DATA_TYPES_NOT_NEEDED

		#ifndef S8
		#define	S8		signed char
		//		typedef signed char		S8;
		#endif

		#ifndef U8
		#define	U8		unsigned char
		//		typedef unsigned char	U8;
		#endif

		#ifndef S16
		#define	S16		signed short
		//		typedef signed short	S16;
		#endif

		#ifndef U16
		#define	U16		unsigned short
		//		typedef unsigned short	U16;
		#endif

		#ifndef S32
		#define	S32		signed long
		//		typedef signed long		S32;
		#endif

		#ifndef U32
		#define	U32		unsigned long
		//		typedef unsigned long	U32;
		#endif

	#endif

#elif defined(__linux__)

	#include <stddef.h>
	#include <asm/types.h>

	#define	GSC_EXPORT

	#ifndef GSC_DATA_TYPES_NOT_NEEDED

		typedef __s8	S8;
		typedef __u8	U8;
		typedef __s16	S16;
		typedef __u16	U16;
		typedef __s32	S32;
		typedef __u32	U32;

	#endif

#else

	#error OS IS UNDEFINED.

#endif



#endif
