// Any Device - Utilities - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/common/utils/gsc_util_pci9080.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <errno.h>
#include <stdio.h>

#include "gsc_common.h"
#include "gsc_pci9080.h"
#include "gsc_util.h"



/* #defines	*************************************************************/

#define	_PCI_REG(a)	"PCI " #a, GSC_PCI_9080_##a
#define	_PLX_REG(a)	"PLX " #a, GSC_PLX_9080_##a



/* variables	*************************************************************/

const gsc_util_reg_def_t	gsc_pci9080_pci[]	=
{
	// PCI9080
	{ _PCI_REG(VIDR)		},
	{ _PCI_REG(DIDR)		},
	{ _PCI_REG(CR)			},
	{ _PCI_REG(SR)			},
	{ _PCI_REG(REV)			},
	{ _PCI_REG(CCR)			},
	{ _PCI_REG(CLSR)		},
	{ _PCI_REG(LTR)			},
	{ _PCI_REG(HTR)			},
	{ _PCI_REG(BISTR)		},
	{ _PCI_REG(BAR0)		},
	{ _PCI_REG(BAR1)		},
	{ _PCI_REG(BAR2)		},
	{ _PCI_REG(BAR3)		},
	{ _PCI_REG(BAR4)		},
	{ _PCI_REG(BAR5)		},
	{ _PCI_REG(CIS)			},
	{ _PCI_REG(SVID)		},
	{ _PCI_REG(SID)			},
	{ _PCI_REG(ERBAR)		},
	{ _PCI_REG(ILR)			},
	{ _PCI_REG(IPR)			},
	{ _PCI_REG(MGR)			},
	{ _PCI_REG(MLR)			},
	{ NULL, 0				}
};

const gsc_util_reg_def_t	gsc_pci9080_plx[]	=
{
	// Local Configuration Registers: PCI9080
	{ _PLX_REG(LAS0RR)		},
	{ _PLX_REG(LAS0BA)		},
	{ _PLX_REG(MARBR)		},
	{ _PLX_REG(BIGEND)		},
	{ _PLX_REG(EROMRR)		},
	{ _PLX_REG(EROMBA)		},
	{ _PLX_REG(LBRD0)		},
	{ _PLX_REG(DMRR)		},
	{ _PLX_REG(DMLBAM)		},
	{ _PLX_REG(DMLBAI)		},
	{ _PLX_REG(DMPBAM)		},
	{ _PLX_REG(DMCFGA)		},
	{ _PLX_REG(LAS1RR)		},
	{ _PLX_REG(LAS1BA)		},
	{ _PLX_REG(LBRD1)		},

	// Runtime Registers: PCI9080
	{ _PLX_REG(MBOX0)		},
	{ _PLX_REG(MBOX1)		},
	{ _PLX_REG(MBOX2)		},
	{ _PLX_REG(MBOX3)		},
	{ _PLX_REG(MBOX4)		},
	{ _PLX_REG(MBOX5)		},
	{ _PLX_REG(MBOX6)		},
	{ _PLX_REG(MBOX7)		},
	{ _PLX_REG(P2LDBELL)	},
	{ _PLX_REG(L2PDBELL)	},
	{ _PLX_REG(INTCSR)		},
	{ _PLX_REG(CNTRL)		},
	{ _PLX_REG(PCIHIDR)		},
	{ _PLX_REG(PCIHREV)		},

	// DMA Registers: PCI9080
	{ _PLX_REG(DMAMODE0)	},
	{ _PLX_REG(DMAPADR0)	},
	{ _PLX_REG(DMALADR0)	},
	{ _PLX_REG(DMASIZ0)		},
	{ _PLX_REG(DMADPR0)		},
	{ _PLX_REG(DMACSR0)		},
	{ _PLX_REG(DMAMODE1)	},
	{ _PLX_REG(DMAPADR1)	},
	{ _PLX_REG(DMALADR1)	},
	{ _PLX_REG(DMASIZ1)		},
	{ _PLX_REG(DMADPR1)		},
	{ _PLX_REG(DMACSR1)		},
	{ _PLX_REG(DMAARB)		},
	{ _PLX_REG(DMATHR)		},

	// Messaging Queue Registers: PCI9080
	{ _PLX_REG(OPLFIS)		},
	{ _PLX_REG(OPLFIM)		},
	{ _PLX_REG(IQP)			},
	{ _PLX_REG(OQP)			},
	{ _PLX_REG(MQCR)		},
	{ _PLX_REG(QBAR)		},
	{ _PLX_REG(IFHPR)		},
	{ _PLX_REG(IFTPR)		},
	{ _PLX_REG(IPHPR)		},
	{ _PLX_REG(IPTPR)		},
	{ _PLX_REG(OFHPR)		},
	{ _PLX_REG(OFTPR)		},
	{ _PLX_REG(OPHPR)		},
	{ _PLX_REG(OPTPR)		},
	{ _PLX_REG(QSR)			},

	{ NULL, 0				}
};


