// Any Device - Utilities - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/common/utils/gsc_util_select.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <stdio.h>

#include "gsc_util.h"



/*****************************************************************************
*
*	Function:	gsc_select_1_board
*
*	Purpose:
*
*		Select the board to utilize when more than one is present.
*
*	Arguments:
*
*		qty		The number of installed boards.
*
*		index	The board to use. This starts as the default, which
*				we adjust here as appropriate.
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
*****************************************************************************/

int gsc_select_1_board(int qty, int* index)
{
	char	buf[128];
	int		errs	= 0;

	if (qty < 2)
	{
		index[0]	= 0;
	}
	else if ((index[0] >= 0) && (index[0] < qty))
	{
	}
	else
	{
		printf("Enter a board index from 0 to %d: ", qty - 1);
		fgets(buf, sizeof(buf), stdin);
		sscanf(buf, "%d", index);

		if ((index[0] < 0) || (index[0] >= qty))
		{
			errs	= 1;
			printf("%d is an invalid index.\n", index[0]);
		}
	}

	return(errs);
}



/*****************************************************************************
*
*	Function:	gsc_select_2_boards
*
*	Purpose:
*
*		Select two boards to utilize when more than two are present.
*
*	Arguments:
*
*		qty		The number of installed boards.
*
*		index_1	The first board to use.
*
*		index_2	The second board to use.
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
*****************************************************************************/

int gsc_select_2_boards(int qty, int* index_1, int* index_2)
{
	char	buf[128];
	int		errs	= 0;

	for (;;)	// A convenience loop.
	{
		if (qty == 0)
		{
			errs	= gsc_label_fail_text(1, "no boards present, two are required");
			break;
		}

		if (qty == 1)
		{
			errs	= gsc_label_fail_text(1, "only one board present, two are required");
			break;
		}

		if ((qty == 2) && (index_1[0] < 0) && (index_2[0] < 0))
		{
			index_1[0]	= 0;
			index_2[0]	= 1;
		}

		if ((index_1[0] < 0) || (index_1[0] >= qty))
		{
			printf("Enter the index for the first board: ");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", index_1);
		}

		if ((index_2[0] < 0) || (index_2[0] >= qty))
		{
			printf("Enter the index for the second board: ");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", index_2);
		}

		gsc_label_text("Devices to Access");

		if ((index_1[0] < 0) || (index_1[0] >= qty))
		{
			sprintf(buf, "the first index is invalid: %d", index_1[0]);
			errs	= gsc_label_fail_text(1, buf);
			break;
		}

		if ((index_2[0] < 0) || (index_2[0] >= qty) || (index_2 == index_1))
		{
			sprintf(buf, "the second index is invalid: %d", index_2[0]);
			errs	= gsc_label_fail_text(1, buf);
			break;
		}

		printf("%d and %d\n", index_1[0], index_2[0]);
		break;
	}

	return(errs);
}


