// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/ringbuf/win32/proc.h $
// $Rev: 3630 $
// $Date: 2009-10-12 10:21:12 -0500 (Mon, 12 Oct 2009) $

#ifndef __PROC_H__
#define __PROC_H__

#include "hpdi32.h"




/* #defines	*****************************************************************/

#define	RX_OP_INCREMENT		0
#define	RX_OP_RECEIVE		1
#define	RX_OP_LOAD			2

#define	TX_OP_DISCARD		0
#define	TX_OP_XMIT			1
#define	TX_OP_SAVE			2



/* data types	*************************************************************/

typedef struct
{
	int				done;				// Must be first field.
	int				waiting;			// Waiting to begin.
	void*			dev;
	int				err;
	char			file_name[1024];	// For file access.
	const char*		name;
	int				operation;			// The operation to perform.
	char			op_title[2048];
	int				stop;
	char			text[2048];
	unsigned long	ms_begin;
	unsigned long	ms_end;
	double			bytes;				// Total bytes processed.
} proc_data_t;



/* prototypes	*************************************************************/

int		cable_cmd_0_config(void* dev);
int		cable_cmd_1_config(void* dev);
int		cable_cmd_2_config(void* dev);
int		cable_cmd_3_config(void* dev);
int		cable_cmd_4_config(void* dev);
int		cable_cmd_5_config(void* dev);
int		cable_cmd_6_config(void* dev);
int		favor_tx_config(void* dev);
int		rx_enable_config(void* dev);
int		rx_fifo_ae_config(void* dev);
int		rx_fifo_af_config(void* dev);
int		rx_io_data_size_config(void* dev);
int		rx_io_dma_ch_sel_config(void* dev);
int		rx_io_dma_ctrl_config(void* dev);
int		rx_io_dma_pri_config(void* dev);
int		rx_io_mode_config(void* dev);
int		rx_io_pio_threshold_config(void* dev);
int		rx_io_sc_config(void* dev);
int		rx_io_timeout_config(void* dev);
int		tri_state_config(void* dev);
int		tx_auto_start_config(void* dev);
int		tx_auto_stop_config(void* dev);
int		tx_clock_divider_config(void* dev);
int		tx_enable_config(void* dev);
int		tx_line_valid_on_count_config(void* dev);
int		tx_fifo_ae_config(void* dev);
int		tx_fifo_af_config(void* dev);
int		tx_io_data_size_config(void* dev);
int		tx_io_dma_ch_sel_config(void* dev);
int		tx_io_dma_ctrl_config(void* dev);
int		tx_io_dma_pri_config(void* dev);
int		tx_io_mode_config(void* dev);
int		tx_io_pio_threshold_config(void* dev);
int		tx_io_sc_config(void* dev);
int		tx_line_valid_off_count_config(void* dev);
int		tx_line_valid_on_count_config(void* dev);
int		tx_status_valid_count_config(void* dev);
int		tx_status_valid_mirror_config(void* dev);
int		tx_io_timeout_config(void* dev);
int		tx_remote_throttle_config(void* dev);

int		process_done(void);						// Has processing stopped?
void	process_stop(void);						// Please stop processing.
int		process_thread_sync(proc_data_t* data);	// For Rx/Tx processing.

int		process_start(	U8			index,
						int			api,
						int			qty,
						size_t		size,
						int			tx_op,
						int			rx_op,
						const char*	rx_file);



#endif
