// HPDI32 - Application - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/sbtest/reg.c $
// $Rev: 31046 $
// $Date: 2014-10-27 17:45:58 -0500 (Mon, 27 Oct 2014) $

#include <stdio.h>

#include "main.h"
#include "hpdi32_util.h"
#include "gsc_util.h"



/* variables	*************************************************************/

static const struct
{
	U32	reg;
	int	writeable;
} _reg_list[]	=
{
	/* reg						writeable	*/
	{ GSC_PCI_9080_VIDR,		0			},
	{ GSC_PCI_9080_DIDR,		0			},
	{ GSC_PCI_9080_CR,			0			},
	{ GSC_PCI_9080_SR,			0			},
	{ GSC_PCI_9080_REV,			0			},
	{ GSC_PCI_9080_CCR,			0			},
	{ GSC_PCI_9080_CLSR,		0			},
	{ GSC_PCI_9080_LTR,			0			},
	{ GSC_PCI_9080_HTR,			0			},
	{ GSC_PCI_9080_BISTR,		0			},
	{ GSC_PCI_9080_BAR0,		0			},
	{ GSC_PCI_9080_BAR1,		0			},
	{ GSC_PCI_9080_BAR2,		0			},
	{ GSC_PCI_9080_BAR3,		0			},
	{ GSC_PCI_9080_BAR4,		0			},
	{ GSC_PCI_9080_BAR5,		0			},
	{ GSC_PCI_9080_CIS,			0			},
	{ GSC_PCI_9080_SVID,		0			},
	{ GSC_PCI_9080_SID,			0			},
	{ GSC_PCI_9080_ERBAR,		0			},
	{ GSC_PCI_9080_ILR,			0			},
	{ GSC_PCI_9080_IPR,			0			},
	{ GSC_PCI_9080_MGR,			0			},
	{ GSC_PCI_9080_MLR,			0			},

	{ GSC_PLX_9080_LAS0RR,		0			},
	{ GSC_PLX_9080_LAS0BA,		0			},
	{ GSC_PLX_9080_MARBR,		0			},
	{ GSC_PLX_9080_BIGEND,		0			},
	{ GSC_PLX_9080_EROMRR,		0			},
	{ GSC_PLX_9080_EROMBA,		0			},
	{ GSC_PLX_9080_LBRD0,		0			},
	{ GSC_PLX_9080_DMRR,		0			},
	{ GSC_PLX_9080_DMLBAM,		0			},
	{ GSC_PLX_9080_DMLBAI,		0			},
	{ GSC_PLX_9080_DMPBAM,		0			},
	{ GSC_PLX_9080_DMCFGA,		0			},
	{ GSC_PLX_9080_LAS1RR,		0			},
	{ GSC_PLX_9080_LAS1BA,		0			},
	{ GSC_PLX_9080_LBRD1,		0			},

	{ GSC_PLX_9080_MBOX0,		0			},
	{ GSC_PLX_9080_MBOX1,		0			},
	{ GSC_PLX_9080_MBOX2,		0			},
	{ GSC_PLX_9080_MBOX3,		0			},
	{ GSC_PLX_9080_MBOX4,		0			},
	{ GSC_PLX_9080_MBOX5,		0			},
	{ GSC_PLX_9080_MBOX6,		0			},
	{ GSC_PLX_9080_MBOX7,		0			},
	{ GSC_PLX_9080_P2LDBELL,	0			},
	{ GSC_PLX_9080_L2PDBELL,	0			},
	{ GSC_PLX_9080_INTCSR,		0			},
	{ GSC_PLX_9080_CNTRL,		0			},
	{ GSC_PLX_9080_PCIHIDR,		0			},
	{ GSC_PLX_9080_PCIHREV,		0			},

	{ GSC_PLX_9080_DMAMODE0,	0			},
	{ GSC_PLX_9080_DMAPADR0,	0			},
	{ GSC_PLX_9080_DMALADR0,	0			},
	{ GSC_PLX_9080_DMASIZ0,		0			},
	{ GSC_PLX_9080_DMADPR0,		0			},
	{ GSC_PLX_9080_DMAMODE1,	0			},
	{ GSC_PLX_9080_DMAPADR1,	0			},
	{ GSC_PLX_9080_DMALADR1,	0			},
	{ GSC_PLX_9080_DMASIZ1,		0			},
	{ GSC_PLX_9080_DMADPR1,		0			},
	{ GSC_PLX_9080_DMACSR0,		0			},
	{ GSC_PLX_9080_DMACSR1,		0			},
	{ GSC_PLX_9080_DMAARB,		0			},
	{ GSC_PLX_9080_DMATHR,		0			},

	{ GSC_PLX_9080_OPLFIS,		0			},
	{ GSC_PLX_9080_OPLFIM,		0			},
	{ GSC_PLX_9080_IQP,			0			},
	{ GSC_PLX_9080_OQP,			0			},
	{ GSC_PLX_9080_MQCR,		0			},
	{ GSC_PLX_9080_QBAR,		0			},
	{ GSC_PLX_9080_IFHPR,		0			},
	{ GSC_PLX_9080_IFTPR,		0			},
	{ GSC_PLX_9080_IPHPR,		0			},
	{ GSC_PLX_9080_IPTPR,		0			},
	{ GSC_PLX_9080_OFHPR,		0			},
	{ GSC_PLX_9080_OFTPR,		0			},
	{ GSC_PLX_9080_OPHPR,		0			},
	{ GSC_PLX_9080_OPTPR,		0			},
	{ GSC_PLX_9080_QSR,			0			},

	{ HPDI32_FRR,				1			},
	{ HPDI32_BCR,				1			},
	{ HPDI32_BSR,				1			},
	{ HPDI32_TAR,				1			},
	{ HPDI32_RAR,				1			},
	{ HPDI32_FSR,				1			},
	{ HPDI32_FDR,				1			},
	{ HPDI32_TSVLCR,			1			},
	{ HPDI32_TLVLCR,			1			},
	{ HPDI32_TLILCR,			1			},
	{ HPDI32_RSCR,				1			},
	{ HPDI32_RLCR,				1			},
	{ HPDI32_ICR,				1			},
	{ HPDI32_ISR,				1			},
	{ HPDI32_TCDR,				1			},
	{ HPDI32_TFSR,				1			},
	{ HPDI32_RFSR,				1			},
	{ HPDI32_TFWR,				1			},
	{ HPDI32_RFWR,				1			},
	{ HPDI32_IELR,				1			},
	{ HPDI32_IHLR,				1			}
};



/*****************************************************************************
*
*	Function:	reg_read_test
*
*	Purpose:
*
*		Verify that all readable registers can be read.
*
*	Arguments:
*
*		dev		The handle of the board to access.
*
*	Returned:
*
*		0		All went well.
*		> 0		The number of errors encountered.
*
*****************************************************************************/

int reg_read_test(void* dev)
{
	int	errs	= 0;
	int	i;
	U32	u32;

	gsc_label_text("Register Read Test");

	for (i = 0; i < (int) ARRAY_ELEMENTS(_reg_list); i++)
		errs	= dev_reg_read(dev, _reg_list[i].reg, &u32, errs == 0);

	if (errs == 0)
		printf("PASS  (%d)\n", i);

	return(errs);
}



/*****************************************************************************
*
*	Function:	reg_write_test
*
*	Purpose:
*
*		Verify that all writeable registers can be written.
*
*	Arguments:
*
*		dev		The handle of the board to access.
*
*	Returned:
*
*		0		All went well.
*		> 0		The number of errors encountered.
*
*****************************************************************************/

int reg_write_test(void* dev)
{
	char	buf[64];
	int		errs	= 0;
	int		i;
	int		ro		= 0;
	int		rw		= 0;
	U32		status;
	U32		u32;

	gsc_label_text("Register Write Test");

	for (i = 0; i < (int) ARRAY_ELEMENTS(_reg_list); i++)
	{
		status	= hpdi32_reg_read(dev, _reg_list[i].reg, &u32);

		if (status != GSC_SUCCESS)
		{
			errs	= 1;
			break;
		}

		status	= hpdi32_reg_write(dev, _reg_list[i].reg, u32);

		if (_reg_list[i].writeable)
			rw++;
		else
			ro++;

		if (((_reg_list[i].writeable) && (status != GSC_SUCCESS)) ||
			((!_reg_list[i].writeable) && (status == GSC_SUCCESS)))
		{
			/* If its RW then there should be no error. */
			/* It its RO then there should be an error. */
			errs++;
			break;
		}
	}

	sprintf(buf, "%d: ro %d, rw %d", i, ro, rw);

	if (errs)
		gsc_label_fail_text(1, buf);
	else
		printf("PASS  (%s)\n", buf);

	return(errs);
}


