// HPDI32 - Utilities - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/utils/util_label.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <errno.h>
#include <stdio.h>
#include <string.h>

#include "hpdi32_util.h"
#include "hpdi32_dsl.h"



/*****************************************************************************
*
*	Function:	label_fail_func
*
*	Purpose:
*
*		Report a failure for the given function if verbose is enabled, and if
*		the status is an error.
*
*	Arguments:
*
*		verbose	Work verbosely?
*
*		func	The name of the function that returned the error.
*
*		status	The status returned by the function.
*
*	Returned:
*
*		1		The status indicated an error.
*		0		The satus did not indicate an error.
*
*****************************************************************************/

int label_fail_func(int verbose, const char* func, U32 status)
{
	char	buf[256];
	int		errs	= (status == GSC_SUCCESS) ? 0 : 1;

	if ((errs) && (func) && (verbose))
	{
		hpdi32_status_text(status, buf, sizeof(buf));
		printf("FAIL <---  (%s(), %s)\n", func, buf);
	}

	return(errs);
}


