// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/button.h $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

/*****************************************************************************
*
*	Export items for the custom button controls.
*
*****************************************************************************/

#ifndef __BUTTON_H__
#define	__BUTTON_H__

#include "visual.h"		/*lint !e537 */



/* typedefs	*****************************************************************/

typedef struct
{
	HBRUSH	brush;
	int		count;
	int		direction;
	int		enable;
	int		height;
	POINT	list[5];
	int		offset;
	HPEN	pen;
	int		width;
} button_arrow_t;

typedef struct
{
	int		count;
	int		enable;
	POINT	list[5];
	HPEN	pen;
} button_polyline_t;

typedef struct
{
	HBRUSH	brush;
	int		enable;
	HPEN	pen;
	RECT	rect;
} button_rect_t;

typedef struct
{
	COLORREF	color_bg;
	COLORREF	color_fg;
	int			enable;
	HFONT		font;
	UINT		length;
	RECT		rect;
	char		text[128];
	int			x;
	int			y;
} button_text_t;

typedef struct _button_t button_t;

struct _button_t
{
	RECT			client;
	HDC				dc;
	device_t*		device;
	int				offset;
	void			(*paint)(HWND control, button_t* data);
	UINT			style;
	int				tmAscent;
	int				tmDescent;

	button_arrow_t	arrow1;
	button_arrow_t	arrow2;

	button_rect_t	inside1;
	button_rect_t	inside2;

	button_text_t	text1;
	button_text_t	text2;

	struct
	{
		button_polyline_t	frame1;
		button_polyline_t	frame2;
		button_polyline_t	ul_out;
		button_polyline_t	ul_mid;
		button_polyline_t	ul_in;
		button_polyline_t	lr_out;
		button_polyline_t	lr_mid;
		button_polyline_t	lr_in;
	} border;
};



/* prototypes	*************************************************************/

void	button_arrow_direction_set(HWND dlg, int id, int direction);
void	button_arrow_offset_set(HWND dlg, int id, int offset);
void	button_init(HWND dlg, device_t* device, int id);
void	button_paint_function_set(HWND dlg, int id, void (*paint)(HWND control, button_t* data));
int		button_text_paint(HWND control, button_t* data, int x, int y, const char* text);
int		button_text_width_get(HWND dlg, int id);
int		button_wave_paint(button_t* data, int x, int y, const wave_t* list);
LRESULT	button_wm_drawitem(DRAWITEMSTRUCT* dis);

int		button_circle_paint(HWND		control,
							button_t*	data,
							int			x,
							int			y,
							HBRUSH		brush,
							int			cross);



#endif
