// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/copy.h $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

/*****************************************************************************
*
*	Export items for the COPY feature.
*
*****************************************************************************/

#ifndef __COPY_H__
#define	__COPY_H__



/* #defines	*****************************************************************/

//							0x0000XX	Applies to COPY_WIDTH and COPY_WRAP
#define	COPY_BM_GETCHECK	0x000100
#define	COPY_CB_GETCURSEL	0x000200	// Take text from a Conbo box selection
#define	COPY_DISABLED		0x000400	// Show "disabled".
#define	COPY_ENABLED		0x000800	// Show "enabled" or "disabled".
#define	COPY_EOL			0x001000
#define	COPY_IF_EXISTS		0x002000	// Do nothing if the handle is NULL.
#define	COPY_INDENT			0x004000	// 2 spaces in front of control text
#define	COPY_LIST_BOX		0x008000
#define	COPY_PREFEED		0x010000	// A New Line before the entry.
#define	COPY_UNDERLINE		0x020000
#define	COPY_VISIBLE		0x040000
#define	COPY_WIDTH			0x080000	// Force width to at least lower 0xXX chars.
#define	COPY_WRAP			0x100000	// Line wrap at lower 0xXX chars.



/* typedefs *****************************************************************/

typedef struct
{
	int				id;
	unsigned int	flags;
} copy_t;



/* prototypes	*************************************************************/

char*	copy_alloc(HWND dlg, size_t size, GLOBALHANDLE* gh);
size_t	copy_list_get_size(HWND dlg, const copy_t* list, size_t size);
void	copy_list_to_clipboard(HWND dlg, const copy_t* list, size_t size);
char*	copy_list(HWND dlg, char* dest, const copy_t* list, size_t size);
void	copy_perform(HWND dlg, GLOBALHANDLE gh);



#endif
