// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/data_xfer.h $
// $Rev: 2902 $
// $Date: 2009-08-09 17:48:49 -0500 (Sun, 09 Aug 2009) $

/*****************************************************************************
*
*	Export items common to the Data Read and Data Write options.
*
*****************************************************************************/

#ifndef __DATA_XFER_H__
#define	__DATA_XFER_H__

#include "service.h"		/*lint !e537 */



/* #defines	*****************************************************************/

#define	_1G	(1024L * 1024L * 1024L)



/* typedef	*****************************************************************/

typedef struct	_data_xfer_t	data_xfer_t;

struct _data_xfer_t
{
	int			abort;			// The I/O operation has been aborted.
	int			abort_request;	// An abort has been rquested.
	BOOL		active;			// Is data being transferred?
	U32			amount;			// The value in the AMOUNT edit box.
	const char*	amount_key;		// The .ini key for the AMOUNT edit box value.
	void*		api_buf;		// Pointer to the API Buffer to use, else NULL.
	U32			api_buf_size;	// Size of the API Buffer, else zero.
	U8*			api_buf_ptr;	// API Buffer transfer progress pointer.
	U8*			app_buf;		// Pointer to the Application Buffer to use.
	U32			app_buf_size;	// Size of the Application Buffer.
	U8*			app_buf_ptr;	// Application Buffer transfer progress pointer.
	device_t*	device;
	HWND		dlg;
	U32			offset;			// Begin data display at this address.
	U32			repeat;			// Number of times to repeat the transfer.
	const char*	section;		// The .ini section name were setting are stored.
	U32			status;
	char		status_global[1024];
	char		status_local[1024];
	DWORD		time_start;		// Time when the transfer process started.
	DWORD		time_stop;		// Time when the transfer process stopped.
	const char*	title;			// The title fragment to put in the title area.
	U32			which;			// HPDI32_WHICH_TX/RX
	U32			xfer_tot;		// Total number of bytes to transfer.
	U32			xfered_tot;		// The total number of bytes transferred.

	void		(*refresh_window)(HWND dlg, data_xfer_t* data);
	void		(*wm_initdialog)(HWND dlg, data_xfer_t* data);
	int			(*xfer_begin)(data_xfer_t* data);
	U32			(*xfer_data)(data_xfer_t* data, U32 xfer, U32* xfered);
	void		(*xfer_end)(data_xfer_t* data);
	void		(*xfer_file)(data_xfer_t* data);
	int			(*xfer_progress)(data_xfer_t* data);

//	U32			repeat;		// Number of times to write out data.
//	WNDPROC		goto_proc;

	struct
	{
		HWND	control;
		U32		count;		// Count of data values on hand.
		U32		page_delta;	// Bytes shown on current page.
		RECT	rect;
		U32		size;		// HPDI32_IO_DATA_SIZE_XX_BITS
		U32		col_delta;	// Bytes shown in a single column.
	} data;					// Where we display data.

	struct
	{
		DWORD	id;
	} thread;
};



/* prototypes	*************************************************************/

LRESULT	data_xfer_service(	HWND			dlg,
							device_t*		device,
							service_type_t	service,
							WPARAM			wParam,
							LPARAM			lParam);



#endif
